Attribute VB_Name = "ComPorts"
' Modul         : ComPorts
' System        : VB 6.0 SP6
' Copyright (C) : E+A Forschungsinstitut Elektromaschinen GmbH, CH-4313 Mhlin
'
' Beschreibung  : Test ob ein entsprechende ComPort im System bekannt ist
'                 ComboBox mit ComPorts-Bezeichungen fllen
'
' Prozeduren    : sub  SerialPortExist    Test ob ein serieller Port im Systemregistriert ist
'                 sub  FillPortCombobox   Combobox mit den Namen von seriellen Ports fllen
'                                         von-bis, und/oder nur vorhandene
'
' nderungen    :
' 24.03.05/Beju : Programmier Beginn
'

Option Explicit

'Port vorhanden im System ja/nein
Public Function SerialPortExist(Port As String) As Boolean
  If InStr(UCase(GetAllComPorts), UCase(Port) & ",") Then
    SerialPortExist = True
  Else
    SerialPortExist = False
  End If
End Function

'Combobox fllen mit Namen von Seriellen Schnittstellen
' -Standard mit Com1 bis Com4
' -Fllen von Com1 bis Com-Anzahl
' -Fllen von Com1 bis Com-Anzahl jedoch nur wenn in der Registry vorhanden
Public Sub FillPortCombobox(Box As Object, Optional Anzahl As Integer, Optional OnlyAvailable As Boolean)
  Dim count As Integer
  Dim vorhanden As String
  
  If Anzahl = 0 Then Anzahl = 4
  If OnlyAvailable Then
    vorhanden = UCase(GetAllComPorts)
    For count = 1 To Anzahl
      If InStr(vorhanden, "COM" & count & ",") Then
        Box.AddItem "Com" & count
      End If
    Next
  Else
    For count = 1 To Anzahl
      Box.AddItem "Com" & count
    Next
  End If
End Sub

'String mit im System (Registry) vorhandenen seriellen Schnittstellen fllen
Private Function GetAllComPorts() As String
  Dim ComExist As String
  Dim count As Integer
    
  For count = 0 To 15
    'Lesen welche Schnittstellen das System kennt...
    ComExist = ComExist & GSGetSetting(HKEY_LOCAL_MACHINE, "hardware\devicemap\serialcomm", "\Device\Serial" & count) & ","
  Next
  GetAllComPorts = ComExist
End Function

